# This file is the entry point to configure your own services.
# Files in the packages/ subdirectory configure your dependencies.

# Put parameters here that don't need to change on each machine where the app is deployed
# https://symfony.com/doc/current/best_practices/configuration.html#application-related-configuration
parameters:
    locale: 'en'
    action_documents_directory: '%kernel.project_dir%/src/Uploads/actions/documents'
    action_company_entities_documents_directory: '%kernel.project_dir%/src/Uploads/actions_company_entities/documents'
    milestone_company_entities_documents_directory: '%kernel.project_dir%/src/Uploads/milestones_company_entities/documents'
    users_images_directory: '%kernel.project_dir%/public/uploads/users/user_images'
    users_images_src: '/uploads/users/user_images'

services:
    # default configuration for services in *this* file
    _defaults:
        autowire: true      # Automatically injects dependencies in your services.
        autoconfigure: true # Automatically registers your services as commands, event subscribers, etc.
        public: false       # Allows optimizing the container by removing unused services; this also means
                            # fetching services directly from the container via $container->get() won't work.
                            # The best practice is to be explicit about your dependencies anyway.

    # makes classes in src/ available to be used as services
    # this creates a service per class whose id is the fully-qualified class name
    App\:
        resource: '../src/*'
        exclude: '../src/{DependencyInjection,Entity,Migrations,Tests,Kernel.php}'

    # controllers are imported separately to make sure services can be injected
    # as action arguments even if you don't extend any base controller class
    App\Controller\:
        resource: '../src/Controller'
        tags: ['controller.service_arguments']

    # add more service definitions when explicit configuration is needed
    # please note that last definitions always *replace* previous ones

    breadcrumb_builder:
        public: true
        alias: 'asprega.breadcrumb.builder'

    security_token:
        public: true
        alias: 'security.token_storage'

    App\EventListener\LoginListener:
        tags:
            - { name: 'kernel.event_listener', event: 'security.interactive_login' }

    App\EventListener\RegisterListener:
        class: App\EventListener\RegisterListener
        tags:
            - { name: kernel.event_subscriber }

    privileges:
        class: App\Service\Privileges
        arguments: ['@doctrine.orm.entity_manager', '@company_entities']

    company_entities:
        class: App\Service\CompanyEntitiesService
        arguments: ['@doctrine.orm.entity_manager']

    logger_actions:
        class: App\Service\LoggerActions
        arguments: ['@doctrine.orm.entity_manager']